/***************************************************************************
 *   Copyright (C) 2004-2014 by Thomas Fischer <fischer@unix-ag.uni-kl.de> *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, see <https://www.gnu.org/licenses/>. *
 ***************************************************************************/
#ifndef KBIBTEX_ONLINESEARCH_GENERAL_H
#define KBIBTEX_ONLINESEARCH_GENERAL_H

#include <KSharedConfig>

#include "onlinesearchabstract.h"

class QSpinBox;

class KLineEdit;

class KBIBTEXNETWORKING_EXPORT OnlineSearchQueryFormGeneral : public OnlineSearchQueryFormAbstract
{
    Q_OBJECT

public:
    explicit OnlineSearchQueryFormGeneral(QWidget *parent);

    bool readyToStart() const;
    void copyFromEntry(const Entry &);

    QMap<QString, QString> getQueryTerms();
    int getNumResults();

private:
    QMap<QString, KLineEdit *> queryFields;
    QSpinBox *numResultsField;
    const QString configGroupName;

    void loadState();
    void saveState();
};

#endif // KBIBTEX_ONLINESEARCH_GENERAL_H
